C YCK 8/2002
C YY track interpolator
C using polynomical interpolation
C Make sure that this program should be run at the
C directory whose subdirectories are a0o2, a2o2, and a4o2.
C
CCCCCC   YYtrack.nml   CCCCCCCCC 
C $input
C afe=0.04      ! [a/Fe] This should be between 0 and 0.6
C Zmetal=0.0034 ! metal abundance Z
C solmass=2.76  ! stellar mass in solar unit
C fout(1)='output.track1'  ! output file name
C fout(2)='output.track2'
C $end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      program YYtrack
C      implicit real*8 (a-h,o-z)
      parameter (nline=150)
      parameter (inda=3)
      parameter (indz=11)
      parameter (indm=35)
      real*8 avalue(inda)
      real*8 zvalue(indz)
      real*8 xmass(indm)
      common /grid/avalue,zvalue,xmass

      character*72 trackname,filename
      real*8 work(5,nline,3),pwork(5,nline)

      data avalue/0.0,0.3,0.6/
      data zvalue/0.00001,0.0001,0.0004,0.001,0.004,0.007,
     +0.01,0.02,0.04,0.06,0.08/
      data xmass/ 0.4,0.5,0.6,0.7,0.8,0.9,1.0,
     +1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
     +2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,
     +3.2,3.4,3.6,3.8,4.0,4.2,4.5,5.0/

      integer ka,kz,km,kf,ntrack,kval,m
      integer a_one,z_one,m_one
      common /single/a_one,z_one,m_one
      real*8 afe,Zmetal,solmass, valpha,vz,vmass,y(3)
      character*72 fout(2)
      namelist /input/afe,Zmetal,solmass,fout
C
      open(unit=4,file='YYtrack.nml',status='old')
      read(unit=4, nml=input)
      close(4)                    
      valpha=afe
      vz=Zmetal
      vmass=solmass

C      write(6,*) 'valpha0-0.6, vz0.00001-0.08, vmass0.4-5.0'
C      read(5,*) valpha, vz, vmass
      write(6,34)valpha, vz, vmass
   34 format(1x,'Input : [a/Fe]=',f6.3,1x,'Z=',f8.5,1x,
     +       'M/Msol=',f6.3)

C input alpha Z mass
C output track1 track2 filenames
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  search the nearby tracks
      call findex(avalue,valpha,inda,ka,a_one)
C aname(ka)
      call findex(zvalue,vz,indz,kz,z_one)
C zname(kz) zlength(kz)
      call findex(xmass,vmass,indm,km,m_one)
C xmname(km)
C
      ntrack=24
      do 100 kf=1,2
      kvar=ka
      if(a_one.eq.1)then
       call interp_z(vz,vmass,pwork,ntrack,kvar,kz,km,kf)
      else
       call interp_z(vz,vmass,work(1,1,1),ntrack,1,kz,km,kf)
       call interp_z(vz,vmass,work(1,1,2),ntrack,2,kz,km,kf)
       call interp_z(vz,vmass,work(1,1,3),ntrack,3,kz,km,kf)
         do 10 i=1,ntrack
         do 20 k=1,5
         do 1 m=1,3
          y(m)=work(k,i,m)
    1    continue
         call newton(avalue,y,3,valpha,pwork(k,i))
   20 continue
   10 continue
      endif
C output filename      
C      write(6,*)' output filename '
C      read(5,'(a)')filename
      filename=fout(kf)
      call write_track(filename,pwork,ntrack)
      ntrack=nline
  100 continue
      stop
      end

      subroutine findex(xi,xbar,n,klo,L_one)
      integer n,klo,khi,k,L_one
      real*8 xi(n),xbar
      L_one=0
C find the grid point,  klo, such that xi(klo)<=xbar, and
C abs(xi(klo)-xbar)<1.
      if(xi(1).ge.xbar)then
        klo=1
        khi=2
        go to 522
      endif
      if(xi(n).le.xbar)then
        klo=n
        khi=n
        go to 522
      endif
      klo=1
      khi=n  
    2 if((khi-klo).gt.1)then
         k=(khi+klo)/2.0
           if(xi(k).gt.xbar)then
              khi=k
           else
              klo=k
           endif
         go to 2
      endif
      if((khi-klo).le.0)then
                write(6,'(21h  interpolation error)')
                stop
      endif 
  522 continue
C now, (klo,khi) is sub-range of xi which contains xbar. 
      if(xi(klo).ne.0.0e0)then
        if(abs((xi(klo)-xbar)/xi(klo)).le.0.5e-5)L_one=1
      else
        if(abs(xi(klo)-xbar).le.0.5e-7)L_one=1
      endif
      return
      end
C track1 nline=24
C track2 nline=150
      subroutine read_track(filename,work,nline,*)
      integer nline,i,k
      real*8 work(5,nline)
      character*72 filename
      character*60 dummy
      common /header/dummy
      open(4, file=filename,status='old',err=999)
      read(4,'(a)')dummy
      do i=1,nline
      read(4,*,end=99,err=99)line,(work(k,i),k=1,5)
      if(i.ne.line)goto 99
      enddo
      close(4)
C      write(6,*)' Input  -> ',filename
      return
  999 close(4)
      return 1
   99 write(6,*)' error... file read in'
      write(6,*)' at ',i
      close(4)
      stop
      end
      subroutine write_track(filename,work,nline)
      integer nline,i,k
      real*8 work(5,nline)
      character*72 filename
      character*60 dummy
      common /header/dummy
      open(4, file=filename,status='new')
      write(4,'(a)')dummy
      do i=1,nline
      write(4,9)i,(work(k,i),k=1,5)
    9 format(i3,1x,5f12.8)
      enddo
      close(4)
      write(6,'(1x,8hOutput: ,a60)')filename
      return
      end 


      subroutine interp_z(z,vmass,pwork,nline,ka,kz,km,kf)
      parameter (inda=3)
      parameter (indz=11)
      parameter (indm=35)
      real*8 avalue(inda)
      real*8 zvalue(indz)
      real*8 xmass(indm)
      common /grid/avalue,zvalue,xmass
      integer ka,kz,km,kf,kvar,nline,i,k,m,mm
       real*8 workz(5,nline,4),pwork(5,nline),z,vmass
       real*8 x(4),y(4)
      integer a_one,z_one,m_one
      common /single/a_one,z_one,m_one

      kvar=kz
        if(z_one.eq.1)then
         call interp_m(vmass,pwork,nline,ka,kvar,km,kf)
        else
          if(kz+2.gt.indz)kvar=indz-2
          if(kz-1.lt.1)kvar=2
         call interp_m(vmass,workz(1,1,1),nline,ka,kvar-1,km,kf)
         call interp_m(vmass,workz(1,1,2),nline,ka,kvar,km,kf)
         call interp_m(vmass,workz(1,1,3),nline,ka,kvar+1,km,kf)
         call interp_m(vmass,workz(1,1,4),nline,ka,kvar+2,km,kf)
         do 10 i=1,nline
         do 20 k=1,5
            mm=kvar-2
         do 1 m=1,4
          mm=mm+1
          x(m)=dlog(zvalue(mm))
          y(m)=workz(k,i,m)
    1    continue
         call newton(x,y,4,dlog(z),pwork(k,i))
   20 continue
   10 continue
        endif
       return
      end
      subroutine interp_m(vmass,pwork,nline,ka,kz,km,kf)
      parameter (inda=3)
      parameter (indz=11)
      parameter (indm=35)
      real*8 avalue(inda)
      real*8 zvalue(indz)
      real*8 xmass(indm),y(4)
      common /grid/avalue,zvalue,xmass
      real*8 workm(5,nline,4),vmass,pwork(5,nline),strx(4)
      character*72 trackname
      integer a_one,z_one,m_one
      common /single/a_one,z_one,m_one
      integer ka,kz,km,kf,kvar,nline,kkip,i,j,k,m

      kkip=km
      if(m_one.eq.1)then
         call make_name(ka,kz,kkip,kf,trackname)
         call read_track(trackname,pwork,nline,*999)
         return
      endif
   99 continue
      kvar=kkip
      if(kkip+2.gt.indm)kvar=indm-2
      if(kkip-1.lt.1)kvar=2
      kvar=kvar-2
      do 8 j=1,4
    9    kvar=kvar+1
         if(kvar.gt.indm)goto 999
         call make_name(ka,kz,kvar,kf,trackname)
         call read_track(trackname,workm(1,1,j),nline,*9)
         strx(j)=xmass(kvar)
    8 continue

         do 10 i=1,nline
         do 20 k=1,5
         do 1 m=1,4
          y(m)=workm(k,i,m)
    1    continue
         call newton(strx,y,4,vmass,pwork(k,i))
   20 continue
   10 continue
      return
  999 continue
C      m_one=0
      kkip=kkip-1
      goto 99
C      stop ' no such file exist...'
      end

      subroutine newton(x,yy,n,xbar,ybar)
      real*8 x(n), y(n),xbar,ybar,yy(n)
      integer n,k,l,np,m
      do k=1,n
       y(k)=yy(k)
      enddo
      do 10 k=1,n-1
      do 20 l=1,(n-k)
        y(l)=(y(l+1)-y(l))/(x(l+k)-x(l))
   20 continue
   10 continue
C      do 30 np=1,n
C      write(6,*)y(np)
C   30 continue
      ybar=y(1)
      do 100 m=2,n
       ybar=ybar*(xbar-x(m))+y(m)
  100 continue
C      write(6,*)xbar,ybar
      return
      end
      subroutine make_name(ka,kz,km,kf,filename)
      parameter (inda=3)
      parameter (indz=11)
      parameter (indm=35)
      character*4 aname(inda)
      data aname/'a0o2','a2o2','a4o2'/
      integer zlength(indz)
      data zlength/12,2*10,3*8,5*6/
      character*12 zname(indz)
      data zname/ 'x76997z00001', 'x7697z0001', 'x7688z0004',
     +'x767z001', 'x758z004', 'x749z007', 'x74z01',
     +'x71z02', 'x65z04', 'x59z06', 'x53z08'/
      character*3 xmname(indm)
      data xmname/'m04','m05','m06','m07','m08','m09','m10',
     +'m11','m12','m13','m14','m15','m16','m17','m18','m19','m20',
     +'m21','m22','m23','m24','m25','m26','m27','m28','m29','m30',
     +'m32','m34','m36','m38','m40','m42','m45','m50'/
      character*7 ftype(2)
      data ftype/'.track1','.track2'/
      character*80 fmt(1)

      character*72 filename,trackname
      integer ka,kz,km,kf

      if(kz.le.3)then
      write(fmt,11)zlength(kz),zlength(kz)
   11 format('(2h./,a4,1h/,a',i2,',1h/,a3,a',i2,',a7)')
      else
      write(fmt,12)zlength(kz),zlength(kz)
   12 format('(2h./,a4,1h/,a',i1,',1h/,a3,a',i1,',a7)')
      endif
C
      write(trackname,fmt)aname(ka),zname(kz),
     +                    xmname(km),zname(kz),ftype(kf)
      filename=trackname
      return
      end
